unit formmain;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ImgList, ActnList, Buttons, ExtCtrls,
	FileCtrl, ComCtrls;

type
	TMainForm = class(TForm)
		edtFolder: TEdit;
		Label1: TLabel;
		btnClose: TBitBtn;
		lbClients: TListBox;
		SpeedButton1: TSpeedButton;
		SpeedButton2: TSpeedButton;
		ActionList: TActionList;
		actOpen: TAction;
		actClose: TAction;
		actQuit: TAction;
		ImageList: TImageList;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
		procedure FormCreate(Sender: TObject);
		procedure actQuitExecute(Sender: TObject);
		procedure edtFolderExit(Sender: TObject);
		procedure actCloseExecute(Sender: TObject);
		procedure actCloseUpdate(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure lbClientsDblClick(Sender: TObject);
	private
		procedure newClient;
		procedure updateClientState;
		{ Private declarations }
	public
		{ Public declarations }
		procedure delClient(AIndex: Integer);
	end;

var
	MainForm: TMainForm;

implementation

uses
	FormClient;

{$R *.DFM}

function GetWindowsTempDir: String;
var
	TempDir: array[0..255] of Char;
begin
	GetTempPath(255, @TempDir);
	Result := StrPas(TempDir);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
	Top :=0;
	Left := 0;
	edtFolder.Text := GetWindowsTempDir;
end;

procedure TMainForm.actQuitExecute(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.edtFolderExit(Sender: TObject);
begin
	if not DirectoryExists(edtFolder.Text) then
	begin
		ShowMessage('Invalid folder: ' + edtFolder.Text);
		edtFolder.Text := GetWindowsTempDir;
	end;
end;

procedure TMainForm.updateClientState;
begin
	StatusBar1.SimpleText := Format('Clients (%d):',[lbClients.Items.Count]);
	edtFolder.Enabled := lbClients.Items.Count = 0;
end;

procedure TMainForm.delClient(AIndex: Integer);
begin
	lbClients.Items.Delete(AIndex);
	updateClientState;
end;

procedure TMainForm.newClient;
var
	f: TClientForm;
begin
	f := TClientForm.Create(Self);
	try
		f.SPLocker.SharedDirectory := edtFolder.Text;
		lbClients.Items.AddObject(f.Caption,f);
		updateClientState;
		f.Show;
		f.SetFocus;
	except
		f.Free;
		raise;
	end;
end;

procedure TMainForm.actCloseUpdate(Sender: TObject);
begin
	TAction(Sender).Enabled := lbClients.ItemIndex > -1;
end;

procedure TMainForm.actCloseExecute(Sender: TObject);
begin
	lbClients.Items.Objects[lbClients.ItemIndex].Free;
	delClient(lbClients.ItemIndex);
end;

procedure TMainForm.actOpenExecute(Sender: TObject);
begin
	newClient;
end;

procedure TMainForm.lbClientsDblClick(Sender: TObject);
begin
	TForm(lbClients.Items.Objects[lbClients.ItemIndex]).SetFocus;
end;

end.
